| API Documentation |  |

- MAIN PAGE
- NAMESPACES
- CLASSES

Public Member Functions | List of all members
nkGraphics::PostProcessPass Class Reference

A post processing pass, during which a shader is used to render a quad fitting on the screen. More...

Inheritance diagram for nkGraphics::PostProcessPass:

## Public Member Functions
Shader * | getShader () const
bool | getBackProcess () const
BlendState * | getBlendState () const
Camera * | getCamera () const
void | setShader (Shader *shade)
virtual void | setBackProcess (bool value)
virtual void | setBlendState (BlendState *state)
void | setCamera (Camera *cam)
virtual void | exportClassToTree (nkExport::Node *rootNode) override
virtual void | importClassFromTree (nkExport::Node *rootNode) override
Public Member Functions inherited from nkGraphics::Pass
| Pass (System *system) noexcept
virtual | ~Pass ()
System * | getSystem () const
TargetOperations * | getParent () const
PASS_TYPE | getType () const
nkMemory::StringView | getName () const
void | setParent (TargetOperations *parent)
void | setName (nkMemory::StringView name)
Public Member Functions inherited from nkExport::Exportable
| Exportable () noexcept
virtual | ~Exportable ()

## Detailed Description

A post processing pass, during which a shader is used to render a quad fitting on the screen.

Usually works with screen space data. Perfect for applying effect on a target for instance.
See TargetOperations::addPostProcessPass() for use.

## Member Function Documentation

## ◆ getShader()

Shader* nkGraphics::PostProcessPass::getShader | ( |  | ) | const

Returns
  The shader used for rendering.

## ◆ getBackProcess()

bool nkGraphics::PostProcessPass::getBackProcess | ( |  | ) | const

Returns
  Whether the post process is a back process pass (true) or not (false). See setBackProcess() for details.

## ◆ getBlendState()

BlendState* nkGraphics::PostProcessPass::getBlendState | ( |  | ) | const

Returns
  The blend state used for rendering.

## ◆ getCamera()

Camera* nkGraphics::PostProcessPass::getCamera | ( |  | ) | const

Returns
  The camera used for the pass.

## ◆ setShader()

void nkGraphics::PostProcessPass::setShader | ( | Shader * | shade | ) |

Sets the shader used for rendering.

Parameters

  shade | The shader to use.

## ◆ setBackProcess()

virtual void nkGraphics::PostProcessPass::setBackProcess | ( | bool | value | ) |
| virtual

Sets whether the pass is a back process pass.
Back process passes only writes to parts of the screen that have no depth written. If disabled, the pass paints over everything.
This can be useful when painting a skybox for instance, to only execute the shader on pixels not hidden.

Parameters

  value | Whether the pass should back process (true) or not (false).

## ◆ setBlendState()

virtual void nkGraphics::PostProcessPass::setBlendState | ( | BlendState * | state | ) |
| virtual

Sets the blend state to use for the pass.

Parameters

  state | The blend state to use.

## ◆ setCamera()

void nkGraphics::PostProcessPass::setCamera | ( | Camera * | cam | ) |

Sets the camera to use. The camera will be the reference to feed the shader pass memory slots.

Parameters

  cam | The camera to use.

## ◆ exportClassToTree()

virtual void nkGraphics::PostProcessPass::exportClassToTree | ( | nkExport::Node * | rootNode | ) |
| override virtual

Exports an item into a tree describing its structure and its data.

Parameters

  rootNode | The node into which the object has to write its related information.

Reimplemented from nkGraphics::Pass.

## ◆ importClassFromTree()

virtual void nkGraphics::PostProcessPass::importClassFromTree | ( | nkExport::Node * | rootNode | ) |
| override virtual

Imports information from a tree which is supposed to describe its structure and data.

Parameters

  rootNode | The root node of the tree holding the information.

Reimplemented from nkGraphics::Pass.

The documentation for this class was generated from the following file:

- Documentation/Headers/NilkinsGraphics/Passes/PostProcessPass.h